---------------------------------
-- + + + + + + + + + + + + + + --
-- + Slot Machine By Habhome + --
-- + + + + + + + + + + + + + + --
-- Newest additions:
-- Sounds
---------------------------------
-- Feel free to use snippets of code if you find them useful for
-- your application or game.
-- ------------------------------
--Thanks to OCAL @ CLker.com where I found many images for the game

version = "1.2"

white = color.new(255,255,255)
black = color.new(0,0,0)
green = color.new(0,200,0)
holdC = color.new(240,110,30,127)

sheight = screen.height()	--Saves a variable with the screen height for easy access
swidth = screen.width()		--Saves a variable with the screen width for easy access

--Draw loading screen
function loadingScreen(msg)
	colorW = color.new(255,255,255)	--Creates the color white
	colorB = color.new(0,0,0,192)		--Creates the color black, alpha 192 (75%)
	shgt = screen.height()		--Saves a variable with the screen height
	swdt = screen.width()		--Saves a variable with the screen width
	text.size(20)		--Set text size to 20 pixel
	text.color(colorW)	--Set text color to white
	screen.fillrect(0,0,swdt,shgt,colorB)	--Fill screen with black
	text.draw(0,shgt/2-10,msg,"center",swdt)	--Draw your message in the center
	screen.update()	--Draw image buffer to screen
end

loadingScreen("Loading Game...")	--Loadfunction is called with a message in quotes which will be displayed

math.randomseed(os.time())
math.random(1)

image.setresource("res.bin")

reel = {image.load("res/reel_motion2.png"), image.load("res/reel_still2.png")}
shadow = image.load("res/shadow.png")
bg = image.load("res/bg.png")
menuslider = image.load("res/menuslider.png")
infoslider = image.load("res/paytable.png")
buttonhighlight = image.load("res/button.png")
cross = image.load("res/cross.png")

sound = {}
setmetatable(sound, {__mode = "v"}) -- make table week to avoid using alot of ram
sound.enabled=true;
sound.list = {}

sound.list["coinSound"] = wav.load("sound/Coin.wav")
sound.list["failSound"] = wav.load("sound/Fail.wav")
sound.list["reelstopSound"] = wav.load("sound/ReelStop.wav")
sound.list["spinSound"] = wav.load("sound/Spin.wav")
sound.list["stopThenSpinSound"] = wav.load("sound/StopThenSpin.wav")
sound.list["winSound"] = wav.load("sound/Win.wav")

function sound.play(name)
	if sound.enabled then
		sound.list[name]:play()
	end
end

function sound.remove(name)
	sound.list[name]:close()
	sound.list[name] = nil
	screen.clear()
end



reely = 60			--Reel position on the screen y cord
reel1x = 45			--Reel1 position on the screen x cord
reel2x = reel1x+106	--Reel2 position on the screen x cord
reel3x = reel2x+106	--Reel3 position on the screen x cord
reelxoff = 0		--Constant for reel image x offset
reel1yoff = 75*7	--Variable for reel1 image y offset
reel2yoff = 75*7	--Variable for reel2 image y offset
reel3yoff = 75*7	--Variable for reel3 image y offset
reel1spin = 2 		--Variable to see if reel1 is spinning (decides what reel to draw)
reel2spin = 2 		--Variable to see if reel2 is spinning (decides what reel to draw)
reel3spin = 2 		--Variable to see if reel3 is spinning (decides what reel to draw)
reel1sc = 0			--Variable to count how many changes reel1 have done
reel2sc = 0			--Variable to count how many changes reel2 have done
reel3sc = 0			--Variable to count how many changes reel3 have done
reel1gc = 20		--Constant for how many changes reel1 whould do before going to stop at it's destined result (Only change this, not for 2 or 3)
reel2gc = reel1gc*2	--Constant for how many changes reel1 whould do before going to stop at it's destined result(double reel1 to keep going as long as reel1 did after it has stopped)
reel3gc = reel1gc*3	--Constant for how many changes reel1 whould do before going to stop at it's destined result(triple reel1 to keep going as long as reel1 did after reel2 has stopped)
reel1result = 0		--Used to store the randomized end result where reel1 will stop after it's iterations
reel2result = 0
reel3result = 0
slidery = 213		--Variable for slidemenu y cord
sliderx = -274		--Variable for infoslide x cord
holdNow = {0,0,0}
holdPrev = {1,1,1}

orange = 0		--Constant for orange y chord on reel
seven = 75		--Constant for seven y chord on reel
bar = 150		--Constant for bar y chord on reel
pear = 225		--Constant for pear y chord on reel
banana = 300	--Constant for banana y chord on reel
cherry = 375	--Constant for cherry y chord on reel
skull = 450		--Constant for skull y cord on reel

pairWin = {1, 2, 4, 4, 8, 16, -10}				--Rewards for a pair: Cherry, Banana, Orange, Pear, Bar, Seven, Skull
trippleWin = {10, 20, 30, 30, 100, 500, -100}	--Rewards for a tripple: Cherry, Banana, Orange, Pear, Bar, Seven, Skull

win = 0
lastwin = 0
prompt = "Push spin"
cash = 10
maxcash = 10
holds = 2

info = false
quit = false	--Boolean to check if the app should quit
x = 0
y = 0

sSave = io.open("save/save.lua")	--Open stats file in read mode(default)
if (sSave ~= nil) then	--if it isn't empty
	input = sSave:read("*l")	--read the first line
	if (input ~= nil) then	--if input isn't empty
		cash = tonumber(input)	--convert input into a number and save as cash
	end
	input = sSave:read("*l")	--read the next line
	if (input ~= nil) then	--if input isn't empty
		maxcash = tonumber(input)	--convert input into a number and save as maxcash
	end
	input = sSave:read("*l")	--read the next line
	if (input ~= nil) then	--if input isn't empty
		holds = tonumber(input)	--convert input into a number and save as holds
	end
	input = sSave:read("*l")	--read the next line
	if (input ~= nil) then	--if input isn't empty
		if(tonumber(input) == 1) then	--decide if sound is on or off
			sound.enabled = true
		else
			sound.enabled = false
		end
	end
	sSave:close()	--close file
end

--Saves your game
function saveStats()	
	sSave = io.open("save/save.lua","w")	--Open stats file in write mode
	if (sSave ~= nil) then	--if it isn't empty
		sSave:write(cash,"\n")	--write cash amount into it
		sSave:write(maxcash,"\n")	--write maxash amount into it
		sSave:write(holds,"\n")	--write holds amount into it
		if(sound.enabled) then
			sSave:write(1,"\n")	--write sound setting into it
		else
			sSave:write(0,"\n")	--write holds amount into it
		end
		sSave:close()	--close file
	end
end

--Screen drawing function for the reels. Need the reel nr to update or 0 for all
function drawReels(reelnr)
	if(reelnr == 1 or reelnr == 0) then
		screen.fillrect(reel1x-2,reely,85,75,white)									--Draw white rectangle behind reel1
		reel[reel1spin]:draw(reel1x-reelxoff,reely-reel1yoff,reel1x,reely,85,75)	--Draw a 85x75 piece from reel image (spin or not) with the reel1 specifications
		shadow:draw(reel1x-2,reely,85,75)											--Draw shadow over reel1 to simulate curve
	end
	if(reelnr == 2 or reelnr == 0) then
		screen.fillrect(reel2x-2,reely,85,75,white)									--Draw white rectangle behind reel2
		reel[reel2spin]:draw(reel2x-reelxoff,reely-reel2yoff,reel2x,reely,85,75)	--Draw a 85x75 piece from reel image (spin or not) with the reel3 specifications
		shadow:draw(reel2x-2,reely,85,75)											--Draw shadow over reel1 to simulate curve
	end
	if(reelnr == 3 or reelnr == 0) then
		screen.fillrect(reel3x-2,reely,85,75,white)									--Draw white rectangle behind reel3
		reel[reel3spin]:draw(reel3x-reelxoff,reely-reel3yoff,reel3x,reely,85,75)	--Draw a 85x75 piece from reel image (spin or not) with the reel3 specifications
		shadow:draw(reel3x-2,reely,85,75)		--Draw shadow over reel1 to simulate curve
	end
	if not info then
		screen.update()	--Update screen
	end
end

--Spin function
function spin()
	reel1sc = 0
	reel2sc = 0
	reelstart = 0
	if(holdNow[1] == 0) then
		reel1result = getRandomObject()
	else
		reelstart = reelstart + 20
		reel2sc = 20
	end
	if(holdNow[2] == 0) then
		reel2result = getRandomObject()
	else
		reelstart = reelstart + 20
	end
	if(holdNow[3] == 0) then
		reel3result = getRandomObject()
	else
		reelstart = reelstart + 20
	end
	for reel3sc=reelstart,reel3gc do
		reel1spin = 2 
		reel2spin = 2 
		reel3spin = 2 
		if(reel1sc<reel1gc and holdNow[1]==0) then
			reel1yoff = reel1yoff - 75
			reel1spin = 1 
		elseif(reel1sc==reel1gc and holdNow[1]==0) then
			reel1yoff = reel1result
			sound.play("stopThenSpinSound")
		end
		if(reel2sc<reel2gc and holdNow[2]==0) then
			reel2yoff = reel2yoff - 75
			reel2spin = 1 
		elseif(reel2sc==reel2gc and holdNow[2]==0) then
			reel2yoff = reel2result
			sound.play("stopThenSpinSound")
		end
		if(holdNow[3]==0) then
			reel3yoff = reel3yoff - 75
			reel3spin = 1 

		end
		reel1sc = reel1sc + 1
		reel2sc = reel2sc + 1
		--reel3sc = reel3sc + 1
		if(reel1yoff<=75*0) then
			reel1yoff = 75*7
		end
		if(reel2yoff<=75*0) then
			reel2yoff = 75*7
		end
		if(reel3yoff<=75*0) then
			reel3yoff = 75*7
		end
		drawReels(0)
		os.wait(9)
	end
	reel3yoff = reel3result
	sound.play("reelstopSound")												----- Here is sound
	reel3spin = 2
	drawReels(0)
end


--check for win function
function check()
	if(reel1result == reel2result and reel2result == reel3result) then	--Tripple win, all are the same
		if(reel2result==cherry) then
			win = trippleWin[1]
		elseif(reel2result==banana) then
			win = trippleWin[2]
		elseif(reel2result==orange) then
			win = trippleWin[3]
		elseif(reel2result==pear) then 
			win = trippleWin[4]
		elseif(reel2result==bar) then
			win = trippleWin[5]
		elseif(reel2result==seven) then
			win = trippleWin[6]
		end
		prompt = "You won $" .. win .. "!"
		sound.play("winSound")												----- Here is sound
		if(reel2result==skull) then
			win = trippleWin[7]
			prompt = "You lose $" .. -win .. "!"
			sound.play("failSound")												----- Here is sound
		elseif(holdNow[1] == 0 and holdNow[2] == 0 and holdNow[3] == 0 and holds <10) then
			holds = holds + 1
		end
		lastwin = win
	elseif(reel1result == reel2result or reel2result == reel3result) then
		if(reel2result==cherry) then
			win = pairWin[1]
		elseif(reel2result==banana) then
			win = pairWin[2]
		elseif(reel2result==orange) then
			win = pairWin[3]
		elseif(reel2result==pear) then
			win = pairWin[4]
		elseif(reel2result==bar) then
			win = pairWin[5]
		elseif(reel2result==seven) then
			win = pairWin[6]
		end
		prompt = "You won $" .. win .. "!"
		sound.play("winSound")												----- Here is sound
		if(reel2result==skull) then
			win = pairWin[7]
			prompt = "You lose $" .. -win .. "!"
			sound.play("failSound")												----- Here is sound
		elseif(holdNow[1] == 0 and holdNow[2] == 0 and holdNow[3] == 0 and holds <10) then
			holds = holds + 1
		end
		lastwin = win
	else
		prompt = "Sorry, you lost."
	end
	cash = cash + win
	if(cash<=0) then
		prompt = "Bankrupt, reset $"
		cash = 10
	end
	if(cash>maxcash) then
		maxcash = cash
	end
	win = 0
	slide(0)
end

--Menu slide move (direction up = 1 direction down = -1)
function slide(direction)
	text.size(15)
	text.color(green)
	if(direction~=0) then
		cg = 14
	else
		cg = 1
	end
	for c=1,cg do
		bg:draw(0,0,100,slidery,210,100)
		slidery = slidery - direction*5
		menuslider:draw(100,slidery,210,100)
		text.draw(110,slidery+40,"$: " .. cash)
		text.draw(195,slidery+40,"Last win: " .. lastwin)
		text.draw(110,slidery+60,"Result: " .. prompt)
		text.draw(110,slidery+79,"Holds: " .. holds)
		text.draw(195,slidery+79,"Most $: " .. maxcash)
		if not info then
			screen.update()	--Update screen
		end
		os.wait(5)
	end
end

--Info slide move (direction right = 1 direction left = -1)
function infoslide(direction)
	info = true
	text.size(15)
	text.color(green)
	if(direction~=0) then
		cg = 18
	else
		cg = 1
	end
	for c=1,cg do
		bg:draw(0,0,0,14,310+sliderx,212)
		--bg:draw(0,0,swidth,sheight)
		drawReels(0)
		slide(0)
		sliderx = sliderx + direction*15
		infoslider:draw(sliderx,14,310,212)
		for u=1,7 do
			text.draw(sliderx+100,u*26+2,"$:" .. trippleWin[u])
			text.draw(sliderx+220,u*26+2,"$:" .. pairWin[u])
		end
		screen.update()
		os.wait(3)
	end
	info = false
end

--Click function
function checkClick()
	if ((x>=310) and (x<=393) and (y>=180) and (y<=218)) then --Spin clicked
		buttonhighlight:draw(310,180,83,38)
		screen.update()
		sound.play("coinSound")
		os.wait(200)
		bg:draw(0,0,310,180,83,38)
		screen.update()
		sound.play("spinSound")
		cash = cash - 1
		prompt = "Spinning..."	
		slide(0)
		spin()
		check()
		for n=1,3 do
			holdPrev[n] = holdNow[n]
			holdNow[n] = 0
		end
	elseif ((x>=10) and (x<=48) and (y>=180) and (y<=218)) then --Sound button
		if(sound.enabled) then
			sound.enabled = false
			cross:draw(10,180,38,38)
			screen.update()
		else
			sound.enabled = true
			bg:draw(0,0,10,180,38,38)
			screen.update()
		end
	elseif ((x>=0) and (x<=30) and (y>=100) and (y<=140) and (sliderx==-274)) then
		infoslide(1)	--infoslide right
		stayUntilTouch()
		if not quit then
			infoslide(-1)	--infoslide left
		end
	elseif ((x>=180) and (x<=220) and (y>=213) and (y<=240) and (slidery==213)) then
		slide(1)	--Slide up
	elseif ((x>=180) and (x<=220) and (y>=143) and (y<=170) and (slidery==143)) then
		slide(-1)	--Slide down
	elseif ((x>=reel1x-2) and (x<=reel1x+83) and (y>=reely) and (y<=reely+75)) then
		if(holdNow[1]==1) then
			holdNow[1] = 0
			holds = holds + 1
			slide(0)
			drawReels(1)
		elseif(holdPrev[1]==0 and (holdNow[2]==0 or holdNow[3]==0) and holds>0) then
			screen.fillrect(reel1x-2,reely,85,75,holdC)
			holds = holds - 1
			slide(0)
			holdNow[1] = 1
		end
	elseif ((x>=reel2x-2) and (x<=reel2x+83) and (y>=reely) and (y<=reely+75)) then
		if(holdNow[2]==1) then
			holdNow[2] = 0
			holds = holds + 1
			slide(0)
			drawReels(2)
		elseif(holdPrev[2]==0 and (holdNow[1]==0 or holdNow[3]==0) and holds>0) then
			screen.fillrect(reel2x-2,reely,85,75,holdC)
			holds = holds - 1
			slide(0)
			holdNow[2] = 1
		end
	elseif ((x>=reel3x-2) and (x<=reel3x+83) and (y>=reely) and (y<=reely+75)) then
		if(holdNow[3]==1) then
			holdNow[3] = 0
			holds = holds + 1
			slide(0)
			drawReels(3)
		elseif(holdPrev[3]==0 and (holdNow[1]==0 or holdNow[2]==0) and holds>0) then
			screen.fillrect(reel3x-2,reely,85,75,holdC)
			holds = holds - 1
			slide(0)
			holdNow[3] = 1
		end
	end
	clearQue()
end

--Stays until screen is pressed
function stayUntilTouch()
	while true do 
		if (control.read()==1) then
			if (control.isTouch() == 1) and (touch.click() == 1) then
				break
			elseif (control.isButton()==1) then	
				if(button.click() == 1) then	
					quit = true
					break
				end
			end
		else
			os.sleep(10)
		end
	end
end

--Randomize reel result
function getRandomObject()
	randomNr = math.random(1,100)
	if(randomNr>=1 and randomNr<=25) then		--25%
		return cherry
	elseif(randomNr>=26 and randomNr<=43) then	--18%
		return banana
	elseif(randomNr>=44 and randomNr<=58) then	--15%
		return pear
	elseif(randomNr>=59 and randomNr<=73) then	--15%
		return orange
	elseif(randomNr>=74 and randomNr<=85) then	--12%
		return skull
	elseif(randomNr>=86 and randomNr<=95) then	--10%
		return bar
	else										--5%
		return seven
	end
end

--Clear event que function
function clearQue()
	os.wait(50)
	while (control.read()==1) do 
		control.isTouch()
	end
end


bg:draw(0,0,swidth,sheight)
text.size(10)
text.color(black)
text.draw(1,230,"V" .. version .. ", Habhome")
menuslider:draw(100,slidery,210,100)
infoslider:draw(sliderx,14,310,212)
drawReels(0)
if(not sound.enabled) then
	cross:draw(10,180,38,38)
end
screen.update()
while true do 
	if (control.read()==1) then
		if (control.isTouch() == 1) and (touch.click() == 1) then
			x, y = touch.pos()
			checkClick()
		elseif (control.isButton()==1) then	
			if(button.click() == 1) then	
				break
			end
		end
	else
	  os.sleep(10)	
  end
	if(quit == true) then
		break
	end
end

saveStats()

reel[1]:close()
reel[2]:close()
shadow:close()
bg:close()
buttonhighlight:close()
menuslider:close()

sound.remove("coinSound")
sound.remove("failSound")
sound.remove("reelstopSound")
sound.remove("spinSound")
sound.remove("stopThenSpinSound")
sound.remove("winSound")
collectgarbage("collect")